"""Constants for typical argument names for Tkinter widgets."""

from typing import Literal

__all__ = [
    "EXPORTSELECTION",
    "FG",
    "FONT",
    "FOREGROUND",
    "HIGHLIGHTBACKGROUND",
    "INSERTBORDERWIDTH",
    "INSERTOFFTIME",
    "INSERTONTIME",
    "INSERTWIDTH",
    "SELECTBORDERWIDTH",
    "SELECTFOREGROUND",
    "SHOW",
    "STATE",
    "TAKEFOCUS",
    "TEXTVARIABLE",
    "VALIDATE",
    "VALIDATECOMMAND",
    "VCMD",
    "WIDTH",
    "XSCROLLCOMMAND",
    "AFTER",
    "ANCHOR",
    "BEFORE",
    "EXPAND",
    "FILL",
    "IN_",
    "IPADX",
    "IPADY",
    "PADX",
    "PADY",
    "SIDE",
    "COLUMN",
    "COLUMNSPAN",
    "ROW",
    "ROWSPAN",
    "STICKY",
    "VARIABLE",
    "ONVALUE",
    "OFFVALUE",
    "VALUES",
    "ACTIVESTYLE",
    "LISTVARIABLE",
    "READONLY",
    "ORIENT",
    "MODE",
    "DETERMINATE",
    "INDETERMINATE",
    "TEXT",
    "JUSTIFY",
    "WEIGHT",
    "ACCELERATOR",
    "ACTIVEBACKGROUND",
    "ACTIVEBORDERWIDTH",
    "ACTIVEFOREGROUND",
    "ACTIVERELIEF",
    "ASPECT",
    "AUTOSEPARATORS",
    "BACKGROUND",
    "BD",
    "BELOW",
    "BG",
    "BITMAP",
    "BORDERWIDTH",
    "BUTTONBACKGROUND",
    "BUTTONCURSOR",
    "BUTTONDOWNRELIEF",
    "BUTTONUP",
    "CLASS_",
    "CLOSEENOUGH",
    "COLUMNBREAK",
    "COLUMNS",
    "COMMAND",
    "COMPOUND",
    "CONFINE",
    "CURSOR",
    "DEFAULT",
    "DIGITS",
    "DIRECTION",
    "DISABLEDBACKGROUND",
    "DISABLEDFOREGROUND",
    "DISPLAYCOLUMNS",
    "ELEMENTBORDERWIDTH",
    "FLUSH",
    "FORMAT",
    "FROM_",
    "HANDLEPAD",
    "HANDLESIZE",
    "HEIGHT",
    "HIDEMARGIN",
    "HIGHLIGHTCOLOR",
    "HIGHLIGHTTHICKNESS",
    "ID",
    "IID",
    "IMAGE",
    "INCREMENT",
    "INDEX",
    "INDICATORON",
    "INSERTBACKGROUND",
    "INVALIDCOMMAND",
    "JUMP",
    "LABEL",
    "LABELANCHOR",
    "LABELWIDGET",
    "LEFT",
    "LENGTH",
    "MAXIMUM",
    "MAXUNDO",
    "MENU",
    "MINSIZE",
    "MINWIDTH",
    "OFFRELIEF",
    "OPAQUERESIZE",
    "OPEN",
    "OVERRELIEF",
    "PADDING",
    "PARENT",
    "POSTCOMMAND",
    "READONLYBACKGROUND",
    "RELIEF",
    "REPEATDELAY",
    "REPEATINTERVAL",
    "RESOLUTION",
    "RIGHT",
    "SASHPAD",
    "SASHRELIEF",
    "SASHWIDTH",
    "SCROLLREGION",
    "SELECTBACKGROUND",
    "SELECTCOLOR",
    "SELECTIMAGE",
    "SELECTMODE",
    "SHOWHANDLE",
    "SHOWVALUE",
    "SLIDERLENGTH",
    "SLIDERRELIEF",
    "SPACING1",
    "SPACING2",
    "SPACING3",
    "STRETCH",
    "STYLE",
    "TABS",
    "TAGS",
    "TICKINTERVAL",
    "TITLE",
    "TO",
    "TROUGHCOLOR",
    "UNDERLINE",
    "UNDO",
    "VALUE",
    "WRAP",
    "WRAPLENGTH",
    "XSCROLLINCREMENT",
    "YSCROLLCOMMAND",
    "YSCROLLINCREMENT",
]

EXPORTSELECTION: Literal["exportselection"] = "exportselection"
"""The ``exportselection`` argument."""

FG: Literal["fg"] = "fg"
"""The ``fg`` argument."""

FONT: Literal["font"] = "font"
"""The ``font`` argument."""

FOREGROUND: Literal["foreground"] = "foreground"
"""The ``foreground`` argument."""

HIGHLIGHTBACKGROUND: Literal["highlightbackground"] = "highlightbackground"
"""The ``highlightbackground`` argument."""

INSERTBORDERWIDTH: Literal["insertborderwidth"] = "insertborderwidth"
"""The ``insertborderwidth`` argument."""

INSERTOFFTIME: Literal["insertofftime"] = "insertofftime"
"""The ``insertofftime`` argument."""

INSERTONTIME: Literal["insertontime"] = "insertontime"
"""The ``insertontime`` argument."""

INSERTWIDTH: Literal["insertwidth"] = "insertwidth"
"""The ``insertwidth`` argument."""

SELECTBORDERWIDTH: Literal["selectborderwidth"] = "selectborderwidth"
"""The ``selectborderwidth`` argument."""

SELECTFOREGROUND: Literal["selectforeground"] = "selectforeground"
"""The ``selectforeground`` argument."""

SHOW: Literal["show"] = "show"
"""The ``show`` argument."""

STATE: Literal["state"] = "state"
"""The ``state`` argument."""

TAKEFOCUS: Literal["takefocus"] = "takefocus"
"""The ``takefocus`` argument."""

TEXTVARIABLE: Literal["textvariable"] = "textvariable"
"""The ``textvariable`` argument."""

VALIDATE: Literal["validate"] = "validate"
"""The ``validate`` argument."""

VALIDATECOMMAND: Literal["validatecommand"] = "validatecommand"
"""The ``validatecommand`` argument."""

VCMD: Literal["vcmd"] = "vcmd"
"""The ``vcmd`` argument."""

WIDTH: Literal["width"] = "width"
"""The ``width`` argument."""

XSCROLLCOMMAND: Literal["xscrollcommand"] = "xscrollcommand"
"""The ``xscrollcommand`` argument."""

AFTER: Literal["after"] = "after"
"""The ``after`` argument."""

ANCHOR: Literal["anchor"] = "anchor"
"""The ``anchor`` argument."""

BEFORE: Literal["before"] = "before"
"""The ``before`` argument."""

EXPAND: Literal["expand"] = "expand"
"""The ``expand`` argument."""

FILL: Literal["fill"] = "fill"
"""The ``fill`` argument."""

IN_: Literal["in_"] = "in_"
"""The ``in_`` argument."""

IPADX: Literal["ipadx"] = "ipadx"
"""The ``ipadx`` argument."""

IPADY: Literal["ipady"] = "ipady"
"""The ``ipady`` argument."""

PADX: Literal["padx"] = "padx"
"""The ``padx`` argument."""

PADY: Literal["pady"] = "pady"
"""The ``pady`` argument."""

SIDE: Literal["side"] = "side"
"""The ``side`` argument."""

COLUMN: Literal["column"] = "column"
"""The ``column`` argument."""

COLUMNSPAN: Literal["columnspan"] = "columnspan"
"""The ``columnspan`` argument."""

ROW: Literal["row"] = "row"
"""The ``row`` argument."""

ROWSPAN: Literal["rowspan"] = "rowspan"
"""The ``rowspan`` argument."""

STICKY: Literal["sticky"] = "sticky"
"""The ``sticky`` argument."""

# Checkbutton arguments
VARIABLE: Literal["variable"] = "variable"
"""The ``variable`` argument."""

ONVALUE: Literal["onvalue"] = "onvalue"
"""The ``onvalue`` argument."""

OFFVALUE: Literal["offvalue"] = "offvalue"
"""The ``offvalue`` argument."""

# Combobox arguments
VALUES: Literal["values"] = "values"
"""The ``values`` argument."""

# Listbox arguments
ACTIVESTYLE: Literal["activestyle"] = "activestyle"
"""The ``activestyle`` argument."""

LISTVARIABLE: Literal["listvariable"] = "listvariable"
"""The ``listvariable`` argument."""

# State values
READONLY: Literal["readonly"] = "readonly"
"""The ``readonly`` value."""

# Progressvar arguments
ORIENT: Literal["orient"] = "orient"
"""The ``orient`` argument."""

MODE: Literal["mode"] = "mode"
"""The ``mode`` argument."""

DETERMINATE: Literal["determinate"] = "determinate"
"""The ``determinate`` argument."""

INDETERMINATE: Literal["indeterminate"] = "indeterminate"
"""The ``indeterminate`` argument."""

TEXT: Literal["text"] = "text"
"""The ``text`` argument."""

JUSTIFY: Literal["justify"] = "justify"
"""The ``justify`` argument."""

WEIGHT: Literal["weight"] = "weight"
"""The ``weight`` argument."""

ACCELERATOR: Literal["accelerator"] = "accelerator"
"""The ``accelerator`` argument."""

ACTIVEBACKGROUND: Literal["activebackground"] = "activebackground"
"""The ``activebackground`` argument."""

ACTIVEBORDERWIDTH: Literal["activeborderwidth"] = "activeborderwidth"
"""The ``activeborderwidth`` argument."""

ACTIVEFOREGROUND: Literal["activeforeground"] = "activeforeground"
"""The ``activeforeground`` argument."""

ACTIVERELIEF: Literal["activerelief"] = "activerelief"
"""The ``activerelief`` argument."""

ASPECT: Literal["aspect"] = "aspect"
"""The ``aspect`` argument."""

AUTOSEPARATORS: Literal["autoseparators"] = "autoseparators"
"""The ``autoseparators`` argument."""

BACKGROUND: Literal["background"] = "background"
"""The ``background`` argument."""

BD: Literal["bd"] = "bd"
"""The ``bd`` argument."""

BELOW: Literal["below"] = "below"
"""The ``below`` argument."""

BG: Literal["bg"] = "bg"
"""The ``bg`` argument."""

BITMAP: Literal["bitmap"] = "bitmap"
"""The ``bitmap`` argument."""

BORDERWIDTH: Literal["borderwidth"] = "borderwidth"
"""The ``borderwidth`` argument."""

BUTTONBACKGROUND: Literal["buttonbackground"] = "buttonbackground"
"""The ``buttonbackground`` argument."""

BUTTONCURSOR: Literal["buttoncursor"] = "buttoncursor"
"""The ``buttoncursor`` argument."""

BUTTONDOWNRELIEF: Literal["buttondownrelief"] = "buttondownrelief"
"""The ``buttondownrelief`` argument."""

BUTTONUP: Literal["buttonup"] = "buttonup"
"""The ``buttonup`` argument."""

CLASS_: Literal["class_"] = "class_"
"""The ``class_`` argument."""

CLOSEENOUGH: Literal["closeenough"] = "closeenough"
"""The ``closeenough`` argument."""

COLUMNBREAK: Literal["columnbreak"] = "columnbreak"
"""The ``columnbreak`` argument."""

COLUMNS: Literal["columns"] = "columns"
"""The ``columns`` argument."""

COMMAND: Literal["command"] = "command"
"""The ``command`` argument."""

COMPOUND: Literal["compound"] = "compound"
"""The ``compound`` argument."""

CONFINE: Literal["confine"] = "confine"
"""The ``confine`` argument."""

CURSOR: Literal["cursor"] = "cursor"
"""The ``cursor`` argument."""

DEFAULT: Literal["default"] = "default"
"""The ``default`` argument."""

DIGITS: Literal["digits"] = "digits"
"""The ``digits`` argument."""

DIRECTION: Literal["direction"] = "direction"
"""The ``direction`` argument."""

DISABLEDBACKGROUND: Literal["disabledbackground"] = "disabledbackground"
"""The ``disabledbackground`` argument."""

DISABLEDFOREGROUND: Literal["disabledforeground"] = "disabledforeground"
"""The ``disabledforeground`` argument."""

DISPLAYCOLUMNS: Literal["displaycolumns"] = "displaycolumns"
"""The ``displaycolumns`` argument."""

ELEMENTBORDERWIDTH: Literal["elementborderwidth"] = "elementborderwidth"
"""The ``elementborderwidth`` argument."""

FLUSH: Literal["flush"] = "flush"
"""The ``flush`` argument."""

FORMAT: Literal["format"] = "format"
"""The ``format`` argument."""

FROM_: Literal["from_"] = "from_"
"""The ``from_`` argument."""

HANDLEPAD: Literal["handlepad"] = "handlepad"
"""The ``handlepad`` argument."""

HANDLESIZE: Literal["handlesize"] = "handlesize"
"""The ``handlesize`` argument."""

HEIGHT: Literal["height"] = "height"
"""The ``height`` argument."""

HIDEMARGIN: Literal["hidemargin"] = "hidemargin"
"""The ``hidemargin`` argument."""

HIGHLIGHTCOLOR: Literal["highlightcolor"] = "highlightcolor"
"""The ``highlightcolor`` argument."""

HIGHLIGHTTHICKNESS: Literal["highlightthickness"] = "highlightthickness"
"""The ``highlightthickness`` argument."""

ID: Literal["id"] = "id"
"""The ``id`` argument."""

IID: Literal["iid"] = "iid"
"""The ``iid`` argument."""

IMAGE: Literal["image"] = "image"
"""The ``image`` argument."""

INCREMENT: Literal["increment"] = "increment"
"""The ``increment`` argument."""

INDEX: Literal["index"] = "index"
"""The ``index`` argument."""

INDICATORON: Literal["indicatoron"] = "indicatoron"
"""The ``indicatoron`` argument."""

INSERTBACKGROUND: Literal["insertbackground"] = "insertbackground"
"""The ``insertbackground`` argument."""

INVALIDCOMMAND: Literal["invalidcommand"] = "invalidcommand"
"""The ``invalidcommand`` argument."""

JUMP: Literal["jump"] = "jump"
"""The ``jump`` argument."""

LABEL: Literal["label"] = "label"
"""The ``label`` argument."""

LABELANCHOR: Literal["labelanchor"] = "labelanchor"
"""The ``labelanchor`` argument."""

LABELWIDGET: Literal["labelwidget"] = "labelwidget"
"""The ``labelwidget`` argument."""

LEFT: Literal["left"] = "left"
"""The ``left`` argument."""

LENGTH: Literal["length"] = "length"
"""The ``length`` argument."""

MAXIMUM: Literal["maximum"] = "maximum"
"""The ``maximum`` argument."""

MAXUNDO: Literal["maxundo"] = "maxundo"
"""The ``maxundo`` argument."""

MENU: Literal["menu"] = "menu"
"""The ``menu`` argument."""

MINSIZE: Literal["minsize"] = "minsize"
"""The ``minsize`` argument."""

MINWIDTH: Literal["minwidth"] = "minwidth"
"""The ``minwidth`` argument."""

OFFRELIEF: Literal["offrelief"] = "offrelief"
"""The ``offrelief`` argument."""

OPAQUERESIZE: Literal["opaqueresize"] = "opaqueresize"
"""The ``opaqueresize`` argument."""

OPEN: Literal["open"] = "open"
"""The ``open`` argument."""

OVERRELIEF: Literal["overrelief"] = "overrelief"
"""The ``overrelief`` argument."""

PADDING: Literal["padding"] = "padding"
"""The ``padding`` argument."""

PARENT: Literal["parent"] = "parent"
"""The ``parent`` argument."""

POSTCOMMAND: Literal["postcommand"] = "postcommand"
"""The ``postcommand`` argument."""

READONLYBACKGROUND: Literal["readonlybackground"] = "readonlybackground"
"""The ``readonlybackground`` argument."""

RELIEF: Literal["relief"] = "relief"
"""The ``relief`` argument."""

REPEATDELAY: Literal["repeatdelay"] = "repeatdelay"
"""The ``repeatdelay`` argument."""

REPEATINTERVAL: Literal["repeatinterval"] = "repeatinterval"
"""The ``repeatinterval`` argument."""

RESOLUTION: Literal["resolution"] = "resolution"
"""The ``resolution`` argument."""

RIGHT: Literal["right"] = "right"
"""The ``right`` argument."""

SASHPAD: Literal["sashpad"] = "sashpad"
"""The ``sashpad`` argument."""

SASHRELIEF: Literal["sashrelief"] = "sashrelief"
"""The ``sashrelief`` argument."""

SASHWIDTH: Literal["sashwidth"] = "sashwidth"
"""The ``sashwidth`` argument."""

SCROLLREGION: Literal["scrollregion"] = "scrollregion"
"""The ``scrollregion`` argument."""

SELECTBACKGROUND: Literal["selectbackground"] = "selectbackground"
"""The ``selectbackground`` argument."""

SELECTCOLOR: Literal["selectcolor"] = "selectcolor"
"""The ``selectcolor`` argument."""

SELECTIMAGE: Literal["selectimage"] = "selectimage"
"""The ``selectimage`` argument."""

SELECTMODE: Literal["selectmode"] = "selectmode"
"""The ``selectmode`` argument."""

SHOWHANDLE: Literal["showhandle"] = "showhandle"
"""The ``showhandle`` argument."""

SHOWVALUE: Literal["showvalue"] = "showvalue"
"""The ``showvalue`` argument."""

SLIDERLENGTH: Literal["sliderlength"] = "sliderlength"
"""The ``sliderlength`` argument."""

SLIDERRELIEF: Literal["sliderrelief"] = "sliderrelief"
"""The ``sliderrelief`` argument."""

SPACING1: Literal["spacing1"] = "spacing1"
"""The ``spacing1`` argument."""

SPACING2: Literal["spacing2"] = "spacing2"
"""The ``spacing2`` argument."""

SPACING3: Literal["spacing3"] = "spacing3"
"""The ``spacing3`` argument."""

STRETCH: Literal["stretch"] = "stretch"
"""The ``stretch`` argument."""

STYLE: Literal["style"] = "style"
"""The ``style`` argument."""

TABS: Literal["tabs"] = "tabs"
"""The ``tabs`` argument."""

TAGS: Literal["tags"] = "tags"
"""The ``tags`` argument."""

TICKINTERVAL: Literal["tickinterval"] = "tickinterval"
"""The ``tickinterval`` argument."""

TITLE: Literal["title"] = "title"
"""The ``title`` argument."""

TO: Literal["to"] = "to"
"""The ``to`` argument."""

TROUGHCOLOR: Literal["troughcolor"] = "troughcolor"
"""The ``troughcolor`` argument."""

UNDERLINE: Literal["underline"] = "underline"
"""The ``underline`` argument."""

UNDO: Literal["undo"] = "undo"
"""The ``undo`` argument."""

VALUE: Literal["value"] = "value"
"""The ``value`` argument."""

WRAP: Literal["wrap"] = "wrap"
"""The ``wrap`` argument."""

WRAPLENGTH: Literal["wraplength"] = "wraplength"
"""The ``wraplength`` argument."""

XSCROLLINCREMENT: Literal["xscrollincrement"] = "xscrollincrement"
"""The ``xscrollincrement`` argument."""

YSCROLLCOMMAND: Literal["yscrollcommand"] = "yscrollcommand"
"""The ``yscrollcommand`` argument."""

YSCROLLINCREMENT: Literal["yscrollincrement"] = "yscrollincrement"
"""The ``yscrollincrement`` argument."""
